#include <stdio.h>
#include <stdlib.h>
#include "listas.h"

/** 
  * Crear una función esOrdenado que devuelva 1 si la lista pasado como 
  * parámetro está ordenada de menor a mayor y 0 en caso contrario.
  */
int esOrdenado(Lista L)
{
}

/** 
  * Crear una función insertarOrdenado que añade los elementos a la lista de
  * forma que la lista quede siempre ordenada de menor a mayor. Debe llamar a la
  * función insertar del TAD listas
  */
void insertarOrdenado(int X, Lista L)
{
}

/**
  * Implementar una función Mezclar que tenga como parámetros dos    
  * listas de enteros ordenados de menor a mayor y que devuelva 
  * una nueva lista como unión de ambas con sus elementos 
  * ordenados de la misma forma 
  **/
Lista Mezclar(Lista l1,Lista l2)
{
}

/** 
  * Realizar una función que reciba como argumento una listay cree otra lista 
  * con los datos en orden inverso.
 **/
Lista invertir (Lista cabeza)
{
}

/** 
  * Realizar una función denominada longitud que reciba como argumento una 
  * lista e imprima en pantalla el número de elementos que contiene.
  **/
int longitudL(Lista l) 
{
}


/** 
  * Implementar una función denominada minrepetir que recibe como argumento 
  * una lista de números. Esta función debe encontrar el dato mínimo y contar 
  * el número de veces que se repite este número. El número de repeticiones de 
  * debe guardar en la variable pasada como argumento
  **/
  
int minrepetir (Lista L, int *n_repeticiones)
{
}

/** 
  * Implementa una función que guarde en fichero todos los números de la lista
  * Se deberán guardar los número separados por un character dado como parámetro
  * y que guarde en cada fila del fichero como máximo un número dado por
  * parámetro. La entrada es la lista a guardar, el
  * nombre del fichero, el máximo de números por fila y el separador
  *
  *   Ejemplo. Si tenemos las lista Cabecera -> 3 -> 4 -> 10 -> 11 -> 18
  *            y llamamos a la función del siguiente modo
  *
  *          guarda_lista(L, "fichero.txt", 3, '|')
  * 
  *      El fichero de salida será
  *
  *          3|4|10
  *          11|18
  *
 **/
int guarda_lista(Lista L, const char *nfile, int max, char sep)
{
}

/** 
  * Implementa una función intercambio que dada una lista y dos valores del dato
  * intercambie los nodos de dichos datos en la lista. No debe cambiiar los
  * valores sino los nodos. Se debe llamar a la función buscarAnterior hecha en
  * clase de teoría y a esVacio para comprobar si L está vació. La función debe
  * devolver 1 si ha podido realizar el intercambio y 0 en caso contrario
  *
  *   Ejemplo. Si tenemos las lista Cabecera -> 3 -> 4 -> 10 -> 11 -> 18
  *            y llamamos a la función del siguiente modo
  *
  *          intercambia_nodos(L, 4, 11)
  * 
  *      La lista se verá modificada como sigue
  *
  *          Cabecera -> 3 -> 11 -> 10 -> 4 -> 18
  *
 **/
int intercambia_nodos(Lista L, int dato1, int dato2)
{
}
/** 
  * Implementa una función intercambio que dada una lista y dos valores del dato
  * intercambie los datos en la lista sin intercambiar los nodos. Se debe llamar
  * a la función buscarAnterior hecha en clase de teoría y a esVacio para 
  * comprobar si L está vació. La función debe devolver 1 si ha podido realizar
  * el intercambio y 0 en caso contrario
  *
  *   Ejemplo. Si tenemos las lista Cabecera -> 3 -> 4 -> 10 -> 11 -> 18
  *            y llamamos a la función del siguiente modo
  *
  *          intercambia_valores(L, 4, 11)
  * 
  *      El fichero de salida será
  *
  *          Cabecera -> 3 -> 11 -> 10 -> 4 -> 18
  *
 **/

int intercambia_valores(Lista L, int dato1, int dato2)
{
}

/**
  * Main para probar las funciones. Hay una pequeña prueba para los dos primeros
  * ejercicios. tenéis que hacer otras pruebas para el resto.
  *
  */
int main(int argc, char *argv[])
{
  Lista L;
  int i;

  L = crearLista();

  /* Test primeros dos ejercicios */
  for (i = 0; i < 20; i++) {
    int X = rand() % 1000;
    insertarOrdenado(X,L);
  }
  printf("-----------------------------------------------------------------\n");
  imprimirLista(L);
  if (esOrdenado(L)) printf("Está ordenada\n");
  else printf("No está ordenada\n");
  
  borrarLista(L);
}


